/**@Author: 
 * Diana Mei Leng Wong
 * Michiko Chand
 * Nazih Ajami
 *@Date: November 8, 2006

 *Description: 
 *This class creates the GUI which helps mangers (users with access) to vote for winners based on a 
 *list of employees nominated for awards. This class currently calls methods in the employee class and 
 *in the award class. In prototype 2 this class will call the Vote class to add the managers vote 
 *into the solution. Currently the class hard codes values out of what should be the nomination class. 
 *For prototype 2 the class will also call the Nomination class.
 */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;

public class guiVoteForWinner {

	JFrame mainWindow;

	JTextArea awardDesText = new JTextArea(200, 20);

	JPanel dialogPane = new JPanel();

	Award blankAward = new Award();

	String[] awardList = blankAward.getAllAwardName();

	Employee blankEmployee = new Employee();

	String[] employeeList = blankEmployee.getAllName();

	String[] voteOptions = { "Yes", "No" };

	JComboBox awardListCBox = new JComboBox(awardList);

	public static void main(String args[]) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new guiVoteForWinner();
			}
		});
	}

	public guiVoteForWinner() {

		// ======== mainWindowFrame ========
		mainWindow = new JFrame();
		mainWindow.setTitle("Vote For Winner");
		mainWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mainWindow.setLocation(300, 100);

		dialogPane.setLayout(new BorderLayout());
		dialogPane.setPreferredSize(new Dimension(600, 510));
		mainWindow.setContentPane(dialogPane);

		JPanel contentPanel = new JPanel();
		JPanel logoPanel = new JPanel();
		JPanel votePanel = new JPanel();
		JLabel awardNamelabel = new JLabel();
		JLabel awardDeslabel = new JLabel();
		JScrollPane scrollPane1 = new JScrollPane();
		JLabel nomNamelabel = new JLabel();
		JComboBox nomNameListCBox = new JComboBox(employeeList);
		JLabel votelabel = new JLabel();
		JComboBox voteListCBox = new JComboBox(voteOptions);
		JPanel buttonBar = new JPanel();
		JButton submitButton = new JButton();
		JButton cancelButton = new JButton();
		JButton logOutButton = new JButton();
		JPanel nominationPanel = new JPanel();
		JLabel submitterLabel = new JLabel();
		JLabel commentLabel = new JLabel();
		JTextArea submitter1Text = new JTextArea();
		JTextArea comment1Text = new JTextArea();
		JTextArea submitter2Text = new JTextArea();
		JTextArea comment2Text = new JTextArea();

		// ======== dialogPane ========
		{
			dialogPane.setBorder(new EmptyBorder(12, 12, 12, 12));
			dialogPane
					.setBorder(new javax.swing.border.CompoundBorder(
							new javax.swing.border.TitledBorder(
									new javax.swing.border.EmptyBorder(0, 0, 0,
											0), " ",
									javax.swing.border.TitledBorder.CENTER,
									javax.swing.border.TitledBorder.BOTTOM,
									new java.awt.Font("Dialog",
											java.awt.Font.BOLD, 12),
									java.awt.Color.red), dialogPane.getBorder()));
			dialogPane
					.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
						public void propertyChange(
								java.beans.PropertyChangeEvent e) {
							if ("border".equals(e.getPropertyName()))
								throw new RuntimeException();
						}
					});

			dialogPane.setLayout(new BorderLayout());

			// ======== contentPanel ========
			{
				contentPanel.setLayout(new GridBagLayout());
				((GridBagLayout) contentPanel.getLayout()).columnWidths = new int[] {
						0, 0 };
				((GridBagLayout) contentPanel.getLayout()).rowHeights = new int[] {
						20, 0, 0 };
				((GridBagLayout) contentPanel.getLayout()).columnWeights = new double[] {
						1.0, 1.0E-4 };
				((GridBagLayout) contentPanel.getLayout()).rowWeights = new double[] {
						0.0, 0.0, 1.0E-4 };

				// ======== logoPanel ========
				{
					logoPanel.setLayout(new GridBagLayout());
					((GridBagLayout) logoPanel.getLayout()).columnWidths = new int[] {
							0, 0, 0, 0 };
					((GridBagLayout) logoPanel.getLayout()).rowHeights = new int[] {
							28, 0 };
					((GridBagLayout) logoPanel.getLayout()).columnWeights = new double[] {
							0.0, 0.0, 0.0, 1.0E-4 };
					((GridBagLayout) logoPanel.getLayout()).rowWeights = new double[] {
							0.0, 1.0E-4 };

					// ---- label1 ----
					DrawLogo northLogoPanel = new DrawLogo();
					logoPanel.add(northLogoPanel, new GridBagConstraints(0, 0,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 0),
							300, 100));
				}
				contentPanel.add(logoPanel, new GridBagConstraints(0, 0, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 5, 0), 0, 0));

				// ======== votePanel ========
				{
					votePanel.setLayout(new GridBagLayout());
					((GridBagLayout) votePanel.getLayout()).columnWidths = new int[] {
							0, 0, 0, 0 };
					((GridBagLayout) votePanel.getLayout()).rowHeights = new int[] {
							0, 70, 31, 101, 0, 0 };
					((GridBagLayout) votePanel.getLayout()).columnWeights = new double[] {
							0.0, 1.0, 1.0, 1.0E-4 };
					((GridBagLayout) votePanel.getLayout()).rowWeights = new double[] {
							0.0, 1.0, 0.0, 1.0, 0.0, 1.0E-4 };

					// ---- awardNamelabel ----
					awardNamelabel.setText("Award Name:");
					votePanel.add(awardNamelabel, new GridBagConstraints(0, 0,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 20),
							0, 0));
					awardListCBox.addActionListener(new awardList());
					votePanel.add(awardListCBox, new GridBagConstraints(1, 0,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 20),
							0, 0));

					// ---- awardDeslabel ----
					awardDeslabel.setText("Award Description:");
					votePanel.add(awardDeslabel, new GridBagConstraints(0, 1,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 20),
							0, 0));

					// ======== scrollPane1 ========
					{

						// ---- awardDesText ----
						awardDesText.setEditable(false);
						awardDesText.setText("This is the description of the "+(String)awardListCBox.getSelectedItem()+" award");
						scrollPane1.setViewportView(awardDesText);
					}
					votePanel.add(scrollPane1, new GridBagConstraints(1, 1, 2,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 0),
							0, 0));

					// ---- nomNamelabel ----
					nomNamelabel.setText("Select Nominee:");
					votePanel.add(nomNamelabel, new GridBagConstraints(0, 2, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 20),
							0, 0));
					votePanel.add(nomNameListCBox, new GridBagConstraints(1, 2,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 20),
							0, 0));

					// ======== nominationPanel ========
					{
						nominationPanel.setBorder(new TitledBorder("Nominees"));
						nominationPanel.setLayout(new GridBagLayout());
						((GridBagLayout) nominationPanel.getLayout()).columnWidths = new int[] {
								130, 0, 0 };
						((GridBagLayout) nominationPanel.getLayout()).rowHeights = new int[] {
								0, 0, 0, 0 };
						((GridBagLayout) nominationPanel.getLayout()).columnWeights = new double[] {
								0.0, 1.0, 1.0E-4 };
						((GridBagLayout) nominationPanel.getLayout()).rowWeights = new double[] {
								0.0, 0.0, 0.0, 1.0E-4 };

						// ---- submitterLabel ----
						submitterLabel.setText("Submitter(s):");
						nominationPanel.add(submitterLabel,
								new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
										GridBagConstraints.CENTER,
										GridBagConstraints.BOTH, new Insets(0,
												0, 5, 0), 0, 0));

						// ---- commentLabel ----
						commentLabel.setText("Comments:");
						nominationPanel.add(commentLabel,
								new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0,
										GridBagConstraints.CENTER,
										GridBagConstraints.BOTH, new Insets(0,
												0, 5, 0), 0, 0));
						submitter1Text.setEditable(false);
						submitter1Text.setText(blankEmployee.getName(0));
						nominationPanel.add(submitter1Text,
								new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
										GridBagConstraints.CENTER,
										GridBagConstraints.BOTH, new Insets(0,
												0, 0, 0), 0, 0));
						comment1Text.setEditable(false);
						comment1Text.setText("This is the BEST employee EVER!!");
						nominationPanel.add(comment1Text,
								new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0,
										GridBagConstraints.CENTER,
										GridBagConstraints.BOTH, new Insets(0,
												0, 0, 0), 0, 0));
						submitter2Text.setEditable(false);
						submitter2Text.setText(blankEmployee.getName(1));
						nominationPanel.add(submitter2Text,
								new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
										GridBagConstraints.CENTER,
										GridBagConstraints.BOTH, new Insets(0,
												0, 0, 0), 0, 0));
						comment2Text.setEditable(false);
						comment2Text.setText("I LOVE this guy");
						nominationPanel.add(comment2Text,
								new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0,
										GridBagConstraints.CENTER,
										GridBagConstraints.BOTH, new Insets(0,
												0, 0, 0), 0, 0));
					}
					votePanel.add(nominationPanel, new GridBagConstraints(0, 3,
							3, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 20, 0),
							0, 0));

					// ---- votelabel ----
					votelabel.setText("My Vote:");
					votePanel.add(votelabel, new GridBagConstraints(0, 4, 1, 1,
							0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 0, 20),
							0, 0));
					votePanel.add(voteListCBox, new GridBagConstraints(1, 4, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 0, 20),
							0, 0));
				}
				contentPanel.add(votePanel, new GridBagConstraints(0, 1, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);

			// ======== buttonBar ========
			{
				buttonBar.setBorder(new EmptyBorder(12, 0, 0, 0));
				buttonBar.setLayout(new GridBagLayout());
				((GridBagLayout) buttonBar.getLayout()).columnWidths = new int[] {
						0, 85, 80 };
				((GridBagLayout) buttonBar.getLayout()).rowWeights = new double[] { 1.0 };

				// ---- submitButton ----
				submitButton.setText("Submit");
				submitButton.setToolTipText("Submit");
				submitButton.addActionListener(new ClickSubmit());
				buttonBar.add(submitButton, new GridBagConstraints(0, 0, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));

				// ---- cancelButton ----
				cancelButton.setText("Cancel");
				cancelButton.setToolTipText("Cancel");
				cancelButton.addActionListener(new ClickCancel());
				buttonBar.add(cancelButton, new GridBagConstraints(1, 0, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0, 0));

				// ---- logOutButton ----
				logOutButton.setText("Log-Out");
				logOutButton.setToolTipText("Log-out");
				logOutButton.addActionListener(new ClickExit());
				buttonBar.add(logOutButton, new GridBagConstraints(2, 0, 1, 1,
						0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
			}
			dialogPane.add(buttonBar, BorderLayout.SOUTH);
		}

		// ---- pack the window and display it ----
		mainWindow.pack();
		mainWindow.setVisible(true);
	}

	class awardList implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			String selectedAward = (String) awardListCBox.getSelectedItem();
			awardDesText.setText(blankAward.getAwardDescription(selectedAward));
		}

	}

	class ClickSubmit implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			mainWindow.dispose();
			new SwitchBoard();
		}
	}

	class ClickCancel implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			mainWindow.dispose();
			new SwitchBoard();
		}

	}

	class ClickExit implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			mainWindow.dispose();
			new SwitchBoard();
		}
	}
}
